import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Random;
import java.util.stream.Stream;


public class Fire {
    GetResponse savedRequests;
    File[] files;


    public Fire() {

    }

    public void fire(int i) {
        i--;
        if (files[i].getName().contains(".txt")) {
            BufferedReader reader = null;
            try {
                reader = new BufferedReader(new FileReader(files[i]));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
            String content = null;
            try {
                content = reader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            //System.out.println(content);


            savedRequests = new GetResponse(content);


        }
    }


    public void showRequest(){
        int count = 0;

        for (File file : files) {

            if (file.getName().contains(".txt") && file.getName().contains(".txt")) {
                count++;
                System.out.println();
                System.out.print(count+" . ");
                BufferedReader reader = null;
                try {
                    reader = new BufferedReader(new FileReader(file));
                } catch (FileNotFoundException e) {
                    e.printStackTrace();
                }
                String content = null;
                try {
                    content = reader.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                //System.out.println(content);


                String[] contentCopy = content.trim().split(" ");

                for (int i = 0; i < contentCopy.length; i++) {
                    if (contentCopy[i].contains("http://")) {
                        System.out.print("url: " + contentCopy[i] + "| ");
                    }


                    if (contentCopy[i].equals("-M") || contentCopy[i].equals("--method")) {
                        System.out.print("method: " + contentCopy[i + 1] + "| ");

                    } else if (contentCopy[i].equals("-H") || contentCopy[i].equals("--headers")) {//setting headers
                        String[] keyValue = contentCopy[i + 1].trim().split(";");//splitting headers from each other
                        System.out.print("headers: ");
                        for (int j = 0; j < keyValue.length; j++) {
                            String[] keyValueCopy = keyValue[j].trim().split(":");//splitting key and value
                            String key = keyValueCopy[0];
                            String value = keyValueCopy[1];

                            System.out.print(key + ": " + value + "/");
                        }
                        i++;
                    } else if (contentCopy[i].equals("-i")) {
                        System.out.println("include headers: true" + "| ");
                    } else if (contentCopy[i].equals("-O") || contentCopy[i].equals("--output")) {
                        System.out.println("output: true" + "| ");
                    } else if (contentCopy[i].equals("-d") || contentCopy[i].equals("--data")) {
                        String cont = contentCopy[i + 1];
                        System.out.print("messageBody: " + cont + "| ");
                    }

                }

            }

        }
        System.out.println();
    }

}