import javax.imageio.IIOException;
import java.io.*;
import java.net.*;
import java.net.http.HttpHeaders;
import java.util.HashMap;
import java.util.Scanner;
import java.nio.file.Files;
import java.util.Map;
import java.io.*;
import java.util.*;


public class GetResponse implements Serializable{

    Fire fire = new Fire();
    Boolean include = false;
    String help;
    String arg;
    String address;
    String completeRequest;
    String content;
    Scanner scanner = new Scanner(System.in);
    HttpURLConnection con;
    URL obj1;


    public GetResponse() {
        String[] copy = splitRequest();
        try {
            response(copy);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public GetResponse(String requestAgain){
        completeRequest = requestAgain;
        String[] copy = requestAgain.trim().split(" ");
        address = copy[0];
        try {
            response(copy);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }


    public String[] splitRequest() {
        completeRequest = scanner.nextLine();
        String[] splitRequest = completeRequest.trim().split(" ");
        address = splitRequest[0];
        for (String test: splitRequest)
        {
            System.out.println(test);
        }
        return splitRequest;
    }


    public void save(String fileName, String str) throws IOException {
        System.out.println(str);
        File file = new File(fileName);
        BufferedWriter writer = new BufferedWriter(new FileWriter(file));
        writer.write(str);
        writer.close();


        File temp = File.createTempFile("file", ".txt", file.getParentFile());
        String delete = "-S";
        String deleteSave = "--save";
        String charset = "UTF-8";
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), charset));
        PrintWriter writerForDelete = new PrintWriter(new OutputStreamWriter(new FileOutputStream(temp), charset));
        for (String line; (line = reader.readLine()) != null; ) {
            line = line.replace(delete, "");
            line = line.replace(deleteSave, "");
            writerForDelete.println(line);
        }
        reader.close();
        writerForDelete.close();
        file.delete();
        temp.renameTo(file);
    }


    public void responseHeader(){
        Map<String, List<String>> map = con.getHeaderFields();
        for (Map.Entry<String, List<String>> entry : map.entrySet()) {
            System.out.println("Key : " + entry.getKey() +
                    " ,Value : " + entry.getValue());
        }

        //get header by 'key'
        String server = con.getHeaderField("Server");
    }





    public void savedList(){
        // try-catch block to handle exceptions
        try {
            File file = new File("/Users/kiana/Courses/2nd Semester/javva projects/CurlInsomnia");
            fire.files = file.listFiles();
            fire.showRequest();
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }


    public boolean isMethod(String test){
        return test.equals("GET") || test.equals("POST") || test.equals("HEAD")
                || test.equals("DELETE") || test.equals("PUT") || test.equals("CONNECT")
                || test.equals("OPTIONS") || test.equals("TRACE") || test.equals("PATCH");
    }


    public HttpURLConnection connect(URL url, String requestType, HttpURLConnection connection) {
        try {
            URLConnection urlConnection = url.openConnection();
            if (urlConnection instanceof HttpURLConnection) {
                connection = (HttpURLConnection) urlConnection;
                String boundary = System.currentTimeMillis() + "";
                connection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
                connection.setRequestMethod(requestType);
                connection.setDoOutput(true);
            }
            return connection;

        } catch (IOException e) {
            System.out.println("E" + e.getMessage());
            return null;
        }
    }

    public void messageBody(String content) {
        String[] message = content.trim().split("&");//splitting headers from each other
        for (int j = 0; j < message.length; j++) {
            String[] messageCopy = message[j].trim().split("=");//splitting key and value
            String first = messageCopy[0];
            String second = messageCopy[1];
            con.setDoOutput(true);
            con.setDoInput(true);
            //con.setRequestProperty(first, second);
            OutputStream os = null;
            try {
                os = con.getOutputStream();
            } catch (IOException e) {
                e.printStackTrace();
            }
            OutputStreamWriter osw = null;
            try {
                osw = new OutputStreamWriter(os, "UTF-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            try {
                osw.write(first);
                osw.write(second);
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                osw.flush();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                osw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                os.close();
            } catch (IOException e) {

            }

        }
    }

    public void post(HttpURLConnection conn, String content){
        conn.setDoOutput(true);
        OutputStream os = null;
        try {
            os = conn.getOutputStream();
        } catch (IOException e) {
            e.printStackTrace();
        }
        OutputStreamWriter osw = null;
        try {
            osw = new OutputStreamWriter(os, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        try {
            osw.write(content);
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            osw.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            osw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            os.close();
        } catch (IOException e) {

        }
    }






    public void response(String[] splitRequestCopy) throws IOException {


        if (!completeRequest.contains("http://") && completeRequest.contains("list")){
            savedList();
            String fireRequest = scanner.nextLine();
            String[] requestsAgain = fireRequest.split(" ");
            for (int i = 2; i < requestsAgain.length; i++){
                fire.fire(Integer.parseInt(requestsAgain[i]));
            }

            return;
        }

        try {
            String link_url = address;
            obj1 = new URL(link_url); //URL Connection Created...
            con = (HttpURLConnection) obj1.openConnection(); //Http URL Connection Created...
            System.out.println(address);
            con.setRequestMethod("GET");


            for (int i = 0; i < splitRequestCopy.length ; i++) {
                if (splitRequestCopy[i].equals("-M") || splitRequestCopy[i].equals("--method")) {
                    if (isMethod(splitRequestCopy[i + 1])) {
                        con = connect(obj1, splitRequestCopy[i + 1], con);
                        System.out.println(con.getRequestMethod());
                        System.out.println("44444444444");
                        i++;

                    }

                }
                else if (splitRequestCopy[i].equals("-H") || splitRequestCopy[i].equals("--headers")) {//setting headers
                    String[] keyValue = splitRequestCopy[i + 1].trim().split(";");//splitting headers from each other
                    for (int j = 0; j < keyValue.length; j++){
                        String[] keyValueCopy = keyValue[j].trim().split(":");//splitting key and value
                        String key = keyValueCopy[0];
                        String value = keyValueCopy[1];
                        con.setDoOutput(true);
                        con.setDoInput(true);
                        con.setRequestProperty(key, value);
                        System.out.println("55555555");

                    }
                    i++;
                }
                else if (splitRequestCopy[i].equals("-i")) {
                    System.out.println("33333333");
                    include = true;

                }

                else if (splitRequestCopy[i].equals("-S") || splitRequestCopy[i].equals("--save")){
                    Random random = new Random();
                    int k = random.nextInt(100000);
                    String requestName = "savedRequest" + k + ".txt";
                    save(requestName, completeRequest);    //saving the whole request ????????
                }

                else if (splitRequestCopy[i].equals("-O") || splitRequestCopy[i].equals("--output")) {
                    try {
                        if (!isMethod(splitRequestCopy[i + 1])) {
                            content = con.getResponseMessage();
                        }
                    } catch (IOException e) {
                        e.printStackTrace();
                    }

                    try {
                        File newTextFile = new File("C:/thetextfile.txt");

                        FileWriter fw = new FileWriter(newTextFile);
                        fw.write(content);
                        fw.close();

                    } catch (IOException iox) {
                        iox.printStackTrace();
                    }
                }

                else if (splitRequestCopy[i].equals("-d") || splitRequestCopy[i].equals("--data")){
                    String cont = splitRequestCopy[i];
                    post(con, cont);
                }

                else if (splitRequestCopy[i].equals("-h") || splitRequestCopy[i].equals("--help")){
                    String help = ("-d, --data DATA     HTTP POST data (H)" +
                            "\n" + "-H, --header LINE   Pass custom header LINE to server (H)"
                            + "\n" + "-h, --help          This help text" +
                            "\n" + "-i      Include protocol headers in the output (H/F)"
                            +"\n" + "-o, --output FILE   Write to FILE instead of stdout" +
                            "");
                    System.out.println(help);
                    return;

                }
            }

            con.setInstanceFollowRedirects(true);
            con.connect();
            //getting the response
            BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
            StringBuffer responseBuffer = new StringBuffer();
            String lines;
            while ((lines = in.readLine()) != null){
                responseBuffer.append(lines + "\n");
            }
            in.close();


            System.out.println("Connection Response Message : "+con.getResponseMessage());
            System.out.println("RESPONE:" + con.getRequestMethod());
            System.out.println(con.getResponseCode());
            System.out.println(responseBuffer.toString());

            if (include)
                responseHeader();

            System.out.println(con.getRequestMethod() + "100000000");

            con.disconnect();
        }

        catch (Exception e) {
            System.out.println( e);
//            System.out.println("<html>\n" +
//                    "<head><title>404 Not Found</title></head>\n" +
//                    "<body>\n" +
//                    "<center><h1>404 Not Found</h1></center>\n" +
//                    "<hr><center>nginx/1.16.0</center>\n" +
//                    "</body>\n" +
//                    "</html>");


        }
    }
}
